/*A beadott program egy egyszer rulettjtk. Kirja a 
rulett tbljt, hogy hova lehet tteket rakni, majd 
prgets parancsa esetn vletlen szmot generl, 
gy szimullja a jtkot. Ngy fggvny van a 
programban - ezek kzl kett a windows.h-bl kivett 
kpernykoordintra ugrs s a betszn/httr 
belltsa. A msik kett kzl az egyik megllaptja, 
hogy a szm fekete-e, a msik pedig kir egy szmot a 
megfelel sznnel (kk httren 0 esetn zld, fekete 
szm esetn fekete, piros esetn piros sznnel). Ezt a 
fggvnyt hasznlja fel a program az elejn, a 
szmtbla kirsnl. Kirja 0-tl 36-ig a szmokat, 
hrom szm utn mindig j sort kezdve (maradkkpzs). 
Lilval kirja a tbbi parancsot (37-48). A kirsok 
utn bekri a parancsot, hogy hova tegyen ttet. Ha 49 
van megadva, az jelenti a prgetst. Ms szmoknl 
(0-48) a ttet kri be, s a ttek tmbjt nveli az 
adott rtkkel HA van mg elg pnze a jtkosnak. 
Ha ekkpp feltette a tteket s 49-es paranccsal 
prget, akkor vletlen szmokat generl s kis 
sznettel kirja ket fellre a megfelel helyre 
(kis ltvnyossgnak csak, egybknt csak az utols 
szmot veszi figyelembe). A prgetett szm fggvnyben 
kiosztja a nyeremnyeket, minden tmbelem rtkre 
alkalmazva a megfelel szorzkat s feltteleket. 
Vgl nullzza minden elemt a tmbnek (ttek 
levtele) s j kr kezddik, kivve ha a clpontszm 
(forrskdban meghatrozva) mr el lett rve, vagy ha 
a pnz 0-ra cskkent, ez esetben vge a jtknak.*/

#include <iostream>
#include <cstdlib>
#include <ctime>
#include <windows.h>

using namespace std;


void menj(int x, int y){
     COORD coord;
     coord.X = x; coord.Y = y;
     SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), coord);
}

void szin(int color){
    HANDLE hcon = GetStdHandle(STD_OUTPUT_HANDLE);
    SetConsoleTextAttribute(hcon,(unsigned short)color);
}

bool szamfekete(int szam){
    if(szam==2 || szam==4 || szam==6 || szam==8 || szam==10 || szam==11 || 
           szam==13 || szam==15 || szam==17 || szam==20 || szam==22 || szam==24 ||
           szam==26 || szam==28 || szam==29 || szam==31 || szam==33 || szam==35)
               return true; else return false;
}

void szamkiir(int szam){
    
    if(szam==0) szin(26);
    else if(szamfekete(szam))
                szin(16);
    else szin(28);
    
    if(szam<10) cout<<" ";
    cout<<szam;
    szin(7);
}


int main(){
    
    cout<<"               R  O  U  L  E  T  T  E                         "<<endl;
    for(int i=0; i<37; ++i){
        szamkiir(i); cout<<" ";
        if( i%3 == 0 ) cout<<endl;
    }
    szin(5);
    cout<<"^  ^  ^"<<endl;
    cout<<"37 38 39";
    menj(8,5); cout<<"___<40";
    menj(8,9); cout<<"___<41";
    menj(8,13); cout<<"___<42";
    menj(17,3); cout<<"  1-18: 43";
    menj(17,4); cout<<" 19-36: 44";
    menj(17,5); cout<<" Paros: 45";
    menj(17,6); cout<<" Ptlan: 46";
    menj(17,7); cout<<" Piros: 47";
    menj(17,8); cout<<"Fekete: 48";
    menj(17,10); szin(4); cout<<"Porgetes: 49";
    szin(7);
    
    long penz=1000;
    long tet[49];   for(int i=0; i<49; ++i) tet[i]=0;
    int porgetettszam=0;
    int parancs=0;
    int tetosszeg;
    
    srand(time(NULL));
    
    while(penz<3000){
        menj(10,16); cout<<"Utolso szam:    ";
        menj(23,16); szamkiir(porgetettszam);
        menj(10,18); cout<<"Penzmennyiseged:                                 ";
        menj(27,18); cout<<penz;
        menj(10,21); cout<<"                                                 ";
        menj(10,20); cout<<"Parancs:                                         ";
        menj(19,20); cin>>parancs;
        if(parancs>=0 && parancs<49){
                menj(10,21); cout<<"Tet osszege:                                 ";
                menj(23,21); cin>>tetosszeg;
                if(tetosszeg<=penz){
                        tet[parancs] += tetosszeg;
                        penz -= tetosszeg;
                } else {
                        menj(10,20);
                        cout<<"Nincs eleg penzed!                                ";
                        cin.get();cin.get();
                }
        } else if(parancs==49) {
                // Prgets
                for(int i=0; i<20; ++i) { porgetettszam = rand()%37;  menj(23,16); szamkiir(porgetettszam); Sleep(60); }
                // Nyeremnyek
                penz += tet[porgetettszam]*36;
                if(porgetettszam!=0){
                        if(porgetettszam%3 == 1)            penz += tet[37]*3;
                            else if(porgetettszam%3 == 2)   penz += tet[38]*3;
                            else                            penz += tet[39]*3;
                        if(porgetettszam <= 12)             penz += tet[40]*3;
                            else if(porgetettszam <= 24)    penz += tet[41]*3;
                            else                            penz += tet[42]*2;
                        if(porgetettszam <= 18)             penz += tet[43]*2;
                            else                            penz += tet[44]*2;
                        if(porgetettszam%2 == 0)            penz += tet[45]*2;
                            else                            penz += tet[46]*2;
                        if(szamfekete(porgetettszam))       penz += tet[48]*2;
                            else                            penz += tet[47]*2;
                }
                // Tttrls
                for(int i=0; i<49; ++i) tet[i]=0;
                // Bukta esetn kilps a ciklusbl
                if(penz==0) break;
        } else {
                menj(10,20);
                cout<<"Rossz parancs!!!!!                                ";
                cin.get();cin.get();
        }
    }
    
    if(penz==0) { menj(10,24); cout<<"Vesztettel!!!!!!!!!!!!!!!!"; }
        else { menj(10,24); cout<<"Nyertel!!!!!!!!!!!!!!!!!!!"; }
    cin.get();cin.get();
    return 0;
}
